import java.util.Scanner;
import java.util.InputMismatchException;
import java.io.File;
import java.io.FileNotFoundException;

/** Starter code for a maze.

    TODO: Eventually it will be able to load a maze and solve it.  Currently
    the print() method should work once getMazeSquare() is implemented.  The
    load() method already reads the first three lines of maze files, but it
    does not process the remaining information regarding walls.

    @author Jed Yang, 2017-01-14
    @author [Partner 1 Name]
    @author [Partner 2 Name]
*/
public class Maze
{
   // private instance variables
   // number of columns and rows in the maze
   private int numCols;
   private int numRows;

   // coordinates for start/end square positions
   private int startCol, startRow;
   private int endCol, endRow;

   // TODO: you will likely want to add one or more private instance variables
   // to store the squares of the maze

   public Maze()
   {
      // TODO: your code here to initialize instance variables you add
   }

   /** Load the maze from a file.
       @return True if successful. */
   public boolean load(String fileName)
   {
      File inputFile = new File(fileName);
      Scanner scanner = null;

      try
      {
         scanner = new Scanner(inputFile);
      }
      catch (FileNotFoundException e)
      {
         System.err.println("Maze file not found: " + fileName);
         return false;
      }

      try
      {
         // read the first three lines of the maze file
         numCols = scanner.nextInt();
         numRows = scanner.nextInt();
         startCol = scanner.nextInt();
         startRow = scanner.nextInt();
         endCol = scanner.nextInt();
         endRow = scanner.nextInt();
      }
      catch (InputMismatchException e)
      {
         System.err.println("Malformed maze file header.");
         return false;
      }

      // check that start/end coordinates are valid
      if (!inRange(startCol, 0, numCols)
         || !inRange(startRow, 0, numRows)
         || !inRange(endCol, 0, numCols)
         || !inRange(endRow, 0, numRows))
      {
         System.err.println("Start or end goal out of bounds.");
         return false;
      }

      // TODO: your code for processing the rest of the file

      return true;
   }

   /** Checks if num is in the range lower (inclusive) to upper (exclusive).
       @param num
       @param lower
       @param upper
       @return True if lower <= num < upper
   */
   private static boolean inRange(int num, int lower, int upper)
   {
      return lower <= num && num < upper;
   }
   
   /** Prints the Maze in a pretty way. */
   public void print()
   {
      // top border
      for (int col = 0; col < numCols; col++)
      {
         System.out.print("+");
         System.out.print("---");
      }
      System.out.println("+");

      // one row at a time
      for (int row = 0; row < numRows; row++)
      {
         // the row of squares with vertical dividing walls
         for (int col = 0; col < numCols; col++)
         {
            // retrieve the square to be printed; this is what allows the
            // print() function to not care about how the squares are stored
            MazeSquare square = getMazeSquare(col, row);

            // left wall of a square
            if (square.hasLeftWall())
            {
               System.out.print("|");
            }
            else
            {
               System.out.print(" ");
            }

            System.out.print(" ");

            // square with possible designation of start/finish
            if (col == startCol && row == startRow)
            {
               System.out.print("S");
            }
            else if (col == endCol && row == endRow)
            {
               System.out.print("F");
            }
            else
            {
               System.out.print(" ");
            }

            System.out.print(" ");
         }
         System.out.println("|"); // right-most wall

         // horizontal walls below the row just printed
         for (int col = 0; col < numCols; col++)
         {
            MazeSquare square = getMazeSquare(col, row);
            System.out.print("+");
            if (square.hasBottomWall())
               System.out.print("---");
            else
               System.out.print("   ");
         }
         System.out.println("+"); // right-most wall
      } // end for
   } // end print()

   /** TODO: Implement this!!  Note that this method allows the print() method
       to not care about how you decide to store the MazeSquare's that you
       loaded.  The 'return null;' line is a "stub" that prevents the compiler
       from complaining.  You should remove that line when you implement this
       method.

       @return The MazeSquare specified by column and row.
   */
   private MazeSquare getMazeSquare(int col, int row)
   {
      return null;
   }

   /** TODO: Write a /few/ lines of code here to process the command line
       argument(s), creates a new Maze, loads, possibly solve, and prints.
   */
   public static void main(String[] args)
   {
   }
}
